/*
 * Impost(er) by ziplock (http://impost.sourceforge.net)
 * File: impost.c (various functions and server routines)
 *
 * Comments: sickbeatz@hotmail.com
 * IRC: #b4b0 on EFNet
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 */

#include "impost.h"
#include "messages.h"

fd_set Socket_List;

int Local_sock;
int Highest_Socket;
int Raw_mode = 0;
int Use_Script = 0;
int Suspect_Size = 0;
int Buffer_Repeats = 0;
int Display_conf_setup = 0;
int Connections[5];
int Has_Opcode_Instructions = 0;
int Detected_NOP_chr = 0;

struct user_h
{

   char Read_History[256][25];
   int  Hist_count;

}; struct user_h User_Info[5];

struct config_options config_opt[] =
{

    /* Abnormal buffer size (max. size before detection) */
     { "SUSPECT_BUFFER_SIZE", DEFAULT_SUS_BUFFER_SIZE, 0 },

    /* Enable logging to 'LOGFILE' variable */
     { "ENABLE_LOGGING", DEFAULT_ENABLE_LOGGING, 0 },
     { "LOGFILE", 0, DEFAULT_LOGFILE },

    /* Max. read length for server's Buffer */
     { "OUR_BUFFER_SIZE", 99999, 0 },

    /* Directory to save all buffer data */
     { "CAPTURE_DIRECTORY", 0, DEFAULT_CAPTURE_DIRECTORY },

    /* Location of shellcode definitions file */
     { "SHELLCODE_DEFINITIONS", 0, DEFAULT_SC_DEFINITIONS }
};

extern int Server_port;
extern int Disable_hexdump;
extern char *Script_File;

char Client_ip[16][5];

/*
** Attempt to find an x86 return address by scanning a buffer from
** end to start. Place each byte in order so a string from the buffer
** that was 'ABCD' would be parsed as 'DCBA'
**
** So far it works pretty well for finding x86 return addresses
** in exploit buffers.. still needs a lot more testing and work tho.
*/
unsigned long Find_Reversed_x86_Address(char *buf)
{
   int i, x, a = 0, hex;
   char nop_pad[] = "0x90909090";
   char *c_str=(char *)malloc(16),
   *n_str = (char *)malloc(16);

#ifdef DEBUG
   printf(".d Scanning buffer for Reversed x86 address..\n");
#endif

    /* Let's start from the end of the buffer and
       move our way towardz the end */
   i = strlen(buf);
   //    printf("i = %d\n",i);
   while (i > 0)
     {
        /* reset our strings */
        memset(c_str, 0, 16);
        memset(n_str, 0, 16);

        /* If there's any NOP padding at the end of the
           buffer let's ignore it */
        hex = (int)buf[i]&0xff;
        while (hex == Detected_NOP_chr || buf[i] == 0x00)
	  {
	     i--; /* Go back 1 more byte */
	     a = i;
	     hex = (int)buf[i]&0xff;
	  }

        x = i - 4; /* go back 4 bytez from current position
		    then put together n_str */
        sprintf(n_str, "0x%x%x%x%x",
		(int)buf[x]&0xff,(int)buf[x-1]&0xff,
		(int)buf[x-2]&0xff,(int)buf[x-3]&0xff);

        /* put c_str together the same way we did with
           n_str but do it from the current position */
        sprintf(c_str, "0x%x%x%x%x",
                (int)buf[i]&0xff, (int)buf[i-1]&0xff,
                (int)buf[i-2]&0xff,(int)buf[i-3]&0xff);

        if (i > strlen(buf)-4 && a == i)
	  return strtoul(c_str, NULL, 16);

        if (i < strlen(buf))
	  {
#ifdef DEBUG
            /* Display current strings to match */
	     printf(".d c_str = %s\n", c_str);
	     printf(".d n_str = %s\n", n_str);
#endif
	     if (!strcmp(c_str, n_str) && strcmp(c_str, nop_pad))
               {
#ifdef DEBUG
		  printf(".d MATCH: 0x%s...\n", c_str);
#endif
		  return strtoul(c_str, NULL, 16); /* Return the match */
               }
	  }

        i--; /* Move back 1 byte */
     }

   return -1; /* Failed */
}

/*
** Capture suspicious data to file
*/
int Impost_Serv_Do_Capture(char *buffer, int c, int Impost_Mode)
{
   FILE  *tmp_file;

   char *capture_filename = (char *) malloc(FILENAME_MAX);
   char *capture_filename_tmp = (char *) malloc(FILENAME_MAX);

   int i, hex, ln = 0;

   struct tm *timeptr;
   time_t tm;

    /* Create New Filename */
   tm = time(NULL);
   (int)timeptr = localtime(&tm);
   strftime(capture_filename_tmp, 14, "%m%y-%H-%M-%S", timeptr);

   sprintf(capture_filename, "%s/capture-%s", config_opt[4].option,
	   capture_filename_tmp);

   printf(" - Capture file: %s\n", capture_filename);

    /* Open file to write captured buffer and
       command history */
   tmp_file = fopen(capture_filename, "a+");

   if (!tmp_file)
     {
        perror("fopen()");
        return -1;
     }

   fprintf(tmp_file, "%s Impost capture file, source IP address: %s\n",
	   Impost_Get_TimeStamp(), Client_ip[c]);
   fprintf(tmp_file, "History of received data pertaining to this session:\n");

   for (i = 0;  i < User_Info[c].Hist_count; i++)
     fprintf(tmp_file, "%2d (%d bytes) = '%s'\n", i+1,
	     strlen(User_Info[c].Read_History[i]),
	     User_Info[c].Read_History[i]);

    /* If raw mode, write command log or convert the buffer
       into code. Simply write the buffer to file in it's raw form */
   if (Raw_mode == 1)
     {
        fprintf(tmp_file, "\nSuspicious buffer (raw data)\n");
        fprintf(tmp_file, "%s", buffer);

        if (config_opt[1].value == 1)
	  write_log("%s Capture file: %s",
		    Impost_Get_TimeStamp(), capture_filename);

        fclose(tmp_file);

        return 0;
     }

    /* Most sensible method of recording possible shellcodes */
   fprintf(tmp_file, "\nSuspicious buffer (C constant string)\n\n");
   fprintf(tmp_file, "const char buffer[] = { ");

   for (i = 0; i < strlen(buffer); i++)
     {
        ln++;

        hex = (int) (buffer[i] & 0xff);

        if ((ln == 12)||(i == 9))
	  {
	     fprintf(tmp_file, "\n  0x%.2x, ", hex);

	     ln = 0;

	     continue;
	  }

        if (i != (strlen(buffer) - 1))
	  fprintf(tmp_file, "0x%.2x, ", hex);
        else
	  fprintf(tmp_file, "0x%.2x };\n", hex);
     }

   if (config_opt[1].value == 1)
     write_log("%s Capturefile: %s",
	       Impost_Get_TimeStamp(), capture_filename);

   fclose(tmp_file);

   return 0;
}

/*
** When a socket is closed, this function is called to remove
** all the temporary command history information from the User_Info
** array to prevent mixups in the logs later on.
*/
int clear_Read_History(int sel)
{
   int i;

   for (i = 0; i < 25; i++)
     *User_Info[sel].Read_History[i] = 0;

   User_Info[sel].Hist_count = 0;

   return 0;
}

/*
** Convert a char to a string
*/
char *ItoS(int C)
{
   char *Ret = (char *)malloc(2);

   sprintf(Ret, "%c", C);
   return Ret;
}

/*
** Print a table of hexidecimals for buffers that
** contain non-printable characters
*/
int Impost_Hexdump(char *buffer, int selected)
{
   char *HexOut; /* Output data */
   char *AscOut;
   char *Last_Buffer;

   int lpos, i, x;
   int hex;

    /* If this option has been disabled, let's go back to
       where we were */
   if (Disable_hexdump)
     return 0;

   if (!(HexOut = (char *)malloc(256)) ||
       !(Last_Buffer = (char *)malloc(256)) ||
       !(AscOut = (char *)malloc(256)))
     {
        printf(ERROR_MALLOC);

        exit(1); /* Shiat */
     }

   memset(HexOut, 0, 256);
   memset(AscOut, 0, 256);

   for (i = 0, lpos = 0; i < strlen(buffer) + 1; i++)
     {
        hex = buffer[i] & 0xff;

        /* Start new line */
        if (lpos == 15)
	  {
	     if (strcmp(Last_Buffer, HexOut))
	       {
		  if (Buffer_Repeats > 0)
		    {
		       printf(IMPOST_HEXDUMP_REPEAT,
			      Connections[selected], Buffer_Repeats);

		       Buffer_Repeats = 0;
		    }

		  strcpy(Last_Buffer, HexOut);

		  printf(IMPOST_HEXDUMP3,
			 Connections[selected], HexOut, AscOut);
	       }
	     else
	       {
		  Buffer_Repeats++;
	       }

	     sprintf(AscOut, "%s",
		     isprint(buffer[i]) ? ItoS(buffer[i]):".");
	     sprintf(HexOut, "%.2X ", hex);

	     lpos = 1;
	     continue;
	  }

        /* Finish hex dump if lpos is less than 15 when i
           is equal to the length of the buffer */
        if (lpos < 15 && i == strlen(buffer))
	  {
	     printf(IMPOST_HEXDUMP1, Connections[selected], HexOut);

            /* Align "Ascii: " with the rest of em */
	     for (x = 0; x < ((15 - lpos) * 3); x++)
	       printf(" ");

	     printf(IMPOST_HEXDUMP2, AscOut);
	     break;
	  }

        sprintf(AscOut, "%s%s", AscOut,
		isprint(buffer[i]) ? ItoS(buffer[i]):".");
        sprintf(HexOut, "%s%.2X ", HexOut, hex);

        lpos++;
     }

   return 0;
}

/*
** Check if the buffer is padded with a pattern of
** repeating bytes ie., 'AAAAAA' and return the total
** count of repeating bytes
*/
int Check_Flatpattern_NOPs(char *buffer)
{
   int i = 1, NOPcount = 0;

   while (buffer[i])
     {
        /* Does the current byte from buffer match
           the one before? */
        if (buffer[i] == buffer[i-1])
	  {
	     NOPcount++;

	  }
	else
	  break;

        i++;
     }

   return NOPcount;
}

/* This function gets called everytime a suspicious buffer is detected,
 * We'll try and analyze the data as much as we can */
int Detected_Buffer(char *buffer, int length, int nops, int nop_start,
		    int selected, int f_Instruct)
{
   int SCinfo;
   int hex = 0, NOPcount = nops;
   //    char *x86_return_address = (char *)malloc(8);
   unsigned long x86_return_address;

   if (config_opt[C_OPT_ENABLE_LOGGING].value == 1)
     {
        write_log("%s Detected suspicious buffer from %s",
		  Impost_Get_TimeStamp(), Client_ip[selected]);
        write_log("            Buffer size: %d", length);
     }

   printf(SP_DETECT, length);

   if (Detected_NOP_chr)
     {
	hex = (int)Detected_NOP_chr & 0xff;

	if (NOPcount > 48)
	  {
        /* Display message for x86 nop count */
	     if (hex == X86_NOP)
	       printf(SP_X86_NOP_COUNT, NOPcount);

        /* More will be added soon */
	  }

	//hex = (int)(buffer[0] & 0xff);
	if (NOPcount < 48)
	  {
        /* Let's check for alternative bytes which could
           be used for padding */
	     hex = (int)buffer[0]&0xff;

	     NOPcount = Check_Flatpattern_NOPs(buffer);
	     if (NOPcount > 48)
	       {
		  printf(SP_OTHER_CHAR_NOP,
			 hex, hex, NOPcount);

		  Detected_NOP_chr = hex;
	       }
	  }
     }

   if (Has_Opcode_Instructions)
     {
    /* Check buffer for polymorphing and try
       and compare with known shellcode signatures */
	SCinfo = SHC_Check_If_Known(buffer);
	SCinfo++;

	if ((x86_return_address = Find_Reversed_x86_Address(buffer)) != -1)
	  {
	     printf(".d Find_Reversed_x86_Address(): 0x%lx\n",
		    x86_return_address);
	  }

	if ((NOPcount > 0) && SCinfo != 1)
	  {
	     if ((NOPcount > 10) && SCinfo < 1)
	       printf(SP_UNKNOWN_WITH_PADDING);

	     if (f_Instruct > 0)
	       printf(SP_FIRST_INST, f_Instruct, (buffer[f_Instruct]&0xff));
	  }
     } else 
     {
	printf(SP_NO_OPCODES);
     }
   

   Detected_NOP_chr = 0;
   Has_Opcode_Instructions = 0;

   return 0;
}

/*
** Count how many 0x90 bytes are in our buffer
*/
int Check_x86_NOPs(char *buffer)
{
   int NOPcount = 0, i = 0, hex;

   while (buffer[i])
     {
        hex = (int)(buffer[i] & 0xff); /* Shorten that sucker */

        if (hex == X86_NOP)
	  NOPcount++;

        i++;
     }

   return NOPcount;
}

/*
** Find starting position of the NOP padding if the slide
** only has 1 byte.
*/
int Find_1byte_NOP_Start(char *buffer, int nop_code)
{
   int nop_start = 0, i;

   for (i = 0; i < strlen(buffer); i++)
     {
        if (buffer[i] == nop_code)
	  {
	     nop_start = i;
	     break;
	  }
     }

   return nop_start;
}

/*
** Read from the currently "active" connection from our list of possible connections
*/
int Impost_Serv_Read_Connection(int selected)
{
   char *buffer, *temp;
   int nl_len, nop_start = 0;
   int i = 0, hex, noprint = 0;
   int NOPcount = 0, f_Instruct = 0;

   if (!(buffer = (char *)malloc(9999)) ||
       !(temp = (char *)malloc(9999)))
     {
        printf(ERROR_MALLOC);

        exit(1);
     }

    /* Make sure the "active" connection is still alive */
   i = 0, nl_len = 0;
   while (recv(Connections[selected], &buffer[i], 1, 0) != 0)
     {
        if (buffer[i] == '\n' || buffer[i] == '\0' || buffer[i] == 0)
	  break;
        i++;
        nl_len++;
     }

    /* Do we still got a connection? */
   if (nl_len == 0)
     {
        if (config_opt[1].value == 1)
	  write_log("%s Lost connection with %s\n",
		    Impost_Get_TimeStamp(), Client_ip[selected]);

        printf(IMPOST_LOST_CONN, Impost_Get_TimeStamp(),
	       Client_ip[selected]);

	clear_Read_History(selected);

        close(Connections[selected]);
        Connections[selected] = 0;

        return 0;
     }

    /* Fix up our buffer */
   if (buffer[nl_len - 1] == '\n' || buffer[nl_len - 1] == '\r')
     buffer[nl_len - 1] = '\0';
   else
     buffer[nl_len] = '\0';

   /* Make sure we're dealing with shellcode before trying to
    * figure out what kinda padding is used */
   Has_Opcode_Instructions = SHC_Has_X86_Opcode(buffer);
   if (Has_Opcode_Instructions)
     {
	NOPcount = Check_x86_NOPs(buffer);
	if (NOPcount > 48)
	  {
	     Detected_NOP_chr = 0x90;
	     nop_start = Find_1byte_NOP_Start(buffer, Detected_NOP_chr);
	  }
	
	/* Try to get the first bye of instruction
       if this buffer contains a shellcode */
	if (NOPcount > 48)
	  {
	     i = nop_start;

	     while (buffer[i])
	       {
		  hex = (int)(buffer[i] & 0xff);
		  if (hex != Detected_NOP_chr)
		    break;

		  f_Instruct++;
		  i++;
	       }
	  }
     }

    /* If the buffer is unusually large, I think it's probably
     * worth checking out. */
   if ((nl_len > config_opt[0].value) || (Has_Opcode_Instructions))
     {
        Detected_Buffer(buffer, nl_len, NOPcount, nop_start, selected, f_Instruct);

        printf(SP_SAVING);
        Impost_Serv_Do_Capture(buffer, selected, SERVER_CAPTURE);

     }
   else /* Add buffer to history for this session */
     {
        strcpy(User_Info[selected].Read_History[User_Info[selected].Hist_count],
	       buffer);
        User_Info[selected].Hist_count++;

        if (config_opt[1].value == 1)
	  write_log("%s read(%d): %s", Impost_Get_TimeStamp(),
		    Connections[selected], buffer);
     }

    /* Is the buffer completely printable? */
   for (i = 0; i < strlen(buffer)-1; i++)
     {
        if (!isprint(buffer[i]) && buffer[i] != '\n' && buffer[i] != '\r')
	  {
	     noprint = 1;
	     break;
	  }
        noprint = 0;
     }

    /* Check if buffer is printable, otherwise call Impost_Hexdump() */
   if (noprint == 0)
     {

        printf(IMPOST_READ, Connections[selected], nl_len, buffer);
     }

   else if (noprint && nl_len > 1)
     Impost_Hexdump(buffer, selected);

    /* We're done with the server-side of things, so if
       there's a script loaded, let it have it's turn */
   if (Use_Script == 1 && ((nl_len < config_opt[0].value) || !NOPcount))
     {
        if (Perl_On_Server_Read(buffer,
				Connections[selected]) == 11) /* Script ordered disconnection :) */
	  {

	     if (config_opt[1].value == 1)
	       write_log("%s Script ended connection with %s",
			 Impost_Get_TimeStamp(), Client_ip[selected]);

	     printf(IMPOST_SCRIPT_DISC, Impost_Get_TimeStamp(), Client_ip[selected]);
	     printf(IMPOST_SCRIPT_DSD, Connections[selected]);

	     close(Connections[selected]);

	     Connections[selected] = 0;
	  }
     }

   if (buffer != NULL)
     free(buffer);
   buffer = NULL;

   return 0;
}

/*
** Get time and create a formatted timestamp
*/
char *Impost_Get_TimeStamp()
{
   struct tm *timeptr;
   time_t tm;
   char *ret;

   tm = time(NULL);
   (int)timeptr = localtime(&tm);

   ret = (char *) malloc(16);
   strftime(ret, 16, "%m/%d/%y %H:%M", timeptr);

   return ret;
}

/*
** Get time and return as CHAR *
*/
char *Impost_Get_Time()
{
   struct tm *timeptr;
   time_t tm;
   char *ret;

   tm = time(NULL);
   (int)timeptr = localtime(&tm);

   ret = (char *) malloc(11);
   strftime(ret, 11, "%H:%M", timeptr);

   return ret;
}

/*
** Shutdown Impost properly
*/
void Impost_Signal_Shutdown(int sign)
{
   int i;

    /* Close any connections currently open */
   for (i = 0; i < 5; i++)
     {
        if (Connections[i] != 0)
	  {
	     close(Connections[i]);
	     printf("%s Closing (%d) connection with %s\n", Impost_Get_TimeStamp(),
                    Connections[i], Client_ip[i]);
	  }
     }

   if (Use_Script == 1)
     {
        printf(IMPOST_UNLOAD_SCRIPT);
        Perl_Unload_Script();
     }

   if (config_opt[1].value == 1)
     write_log("%s Shutting down Impost server",
	       Impost_Get_TimeStamp());

   printf("Exiting!\n");

   exit(0);
}

/*
** Main loop
*/
int Impost_Server_Loop()
{
   int ret, i, connection_count;
   struct timeval tv;

#ifdef HAVE_SIGNAL
   signal(SIGINT,  Impost_Signal_Shutdown);
   signal(SIGTERM, Impost_Signal_Shutdown);
   signal(SIGKILL, Impost_Signal_Shutdown);
#endif

   printf(IMPOST_WAITING);

   while (1)
     {
        FD_ZERO(&Socket_List);
        FD_SET(Local_sock, &Socket_List);

        /* Get a list of connections currently in progress
           to the Impost server */
        for (i = 0, connection_count = 0; i < 5; i++)
	  {
	     if (Connections[i] != 0)
	       {
		  connection_count++;
		  FD_SET(Connections[i], &Socket_List);

                /* Incase of disconnects */
		  if (Connections[i] > Highest_Socket)
                    Highest_Socket = Connections[i];
	       }
	  }

        tv.tv_sec  = 1;
        tv.tv_usec = 0;

        if ((ret = select(Highest_Socket + 1,
			  &Socket_List, NULL, NULL, &tv)) < 0)
	  {
	     perror("select()");
	     exit(1);
	  }

        if (ret != 0)
	  {
	     if (FD_ISSET(Local_sock, &Socket_List))
	       Impost_Accept_Connection();

            /* Check all connections for incoming data */
	     for (i = 0; i < 5; i++)
	       {
		  if (FD_ISSET(Connections[i],
			       &Socket_List))
                    Impost_Serv_Read_Connection(i);
	       }
	  }
     }
}

/*
** Print out current configuration setup
*/
int Display_Variables()
{
   printf(": %s = %d\n"
	  ": %s = %d (%s)\n"
	  ": %s = '%s'\n"
	  ": %s = '%s'\n"
	  ": %s = '%s'\n",
	  config_opt[0].variable, config_opt[0].value,
	  config_opt[1].variable, config_opt[1].value,
	  config_opt[1].value ? "ON" : "OFF",
	  config_opt[2].variable, config_opt[2].option,
	  config_opt[4].variable, config_opt[4].option,
	  config_opt[5].variable, config_opt[5].option);

   return 0;
}

/*
** Accept the new connection if it doesn't over exceed the backlog defined in listen()
*/
int Impost_Accept_Connection()
{
   int i, new_socket, opts;
   int addr_size = sizeof(struct sockaddr_in);
   struct sockaddr_in new_client;

    /* Try and accept the new connection */
   if ((new_socket = accept(Local_sock,
			    (struct sockaddr *)&new_client,
			    (socklen_t *)&addr_size)) == -1)
     {
        perror("accept()");

        exit(1);
     }

#ifdef HAVE_FCNTL

   if ((opts = fcntl(new_socket, F_GETFL)) < 0)
     {
        perror("fcntl()");

        exit(1);
     }

   opts = (opts | O_NONBLOCK);

   if (fcntl(new_socket, F_SETFL, opts) < 0)
     {
        perror("fcntl()");

        exit(1);
     }

#endif

   for (i = 0; i < 5; i++)
     {
        if (Connections[i] == 0)
	  {
	     if (config_opt[1].value == 1)
	       write_log("%s Accepted connection from %s",
			 Impost_Get_TimeStamp(), inet_ntoa(new_client.sin_addr));
	     printf(IMPOST_ACCEPTED, Impost_Get_TimeStamp(),
		    inet_ntoa(new_client.sin_addr));
	     strcpy(Client_ip[i], (char *) inet_ntoa(new_client.sin_addr));

            /* Get greeting message or whatever else the
               perl script wants to do with new connections */
	     if (Use_Script == 1)
	       {
		  Perl_On_Server_Accept(Client_ip[i], new_socket);
	       }

	     Connections[i] = new_socket;
	     return 0;
	  }
     }

   return 0;
}

/*
** Create a non-blocking socket with SO_REUSEADDR enabled and listen on user inputed port
*/
int Impost_Create_Server()
{
   int ru_addr = 1, opts;
   struct sockaddr_in sin_local;

   if ((Local_sock = socket(AF_INET, SOCK_STREAM, 0)) == -1)
     {
        perror("socket()");

        exit(1);
     }

#ifdef HAVE_SETSOCKOPT
   setsockopt(Local_sock, SOL_SOCKET, SO_REUSEADDR,
	      &ru_addr, sizeof(ru_addr));
#endif

#ifdef HAVE_FCNTL

   if ((opts = fcntl(Local_sock, F_GETFL)) < 0)
     {
        perror("fcntl()");
        exit(1);
     }

   opts = (opts | O_NONBLOCK);

   if (fcntl(Local_sock, F_SETFL, opts) < 0)
     {
        perror("fcntl()");
        exit(1);
     }

#endif

   sin_local.sin_family = AF_INET;
   sin_local.sin_port = htons(Server_port);
   sin_local.sin_addr.s_addr = INADDR_ANY;

   if (bind(Local_sock, (struct sockaddr *)&sin_local,
	    sizeof(sin_local)) < 0)
     {
        perror("bind()");

        close(Local_sock);

        exit(1);
     }

   if (Display_conf_setup == 1)
     Display_Variables();

   if (listen(Local_sock, 5) < 0)
     {
        perror("listen()");

        close(Local_sock);

        exit(1);
     }

   Highest_Socket = Local_sock;

   printf(IMPOST_BINDED_PORT, Impost_Get_TimeStamp(), Server_port);

   if (config_opt[1].value == 1)
     write_log("%s Impost server started, binded on port %d",
	       Impost_Get_TimeStamp(), Server_port);

   return 0;
}

/* EOF */
