/*
 * Impost(er) by ziplock (http://ziplock.b4b0.net)
 * File: impost.h (main header)
 *
 * Comments: sickbeatz@hotmail.com
 * IRC: #b4b0 on EFNet
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 */

#include "config.h"

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#ifdef HAVE_UNISTD_H
# include <sys/types.h>
# include <unistd.h>
#endif

#ifdef HAVE_FCNTL
# include <fcntl.h>
#endif

#include <ctype.h>
#include <pwd.h>

#ifdef HAVE_SIGNAL
# include <signal.h>
#endif

#include <time.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>

#ifdef HAVE_LIBPCAP
# include <pcap.h>
# include "packets.h"
#endif

#ifndef HAVE_MEMSET
# define memset(a, b, c) bzero(a, c)
#endif
#ifndef HAVE_STRCHR 
# define strchr(a, b)  index(a, b)
# define strrchr(a, b) index(a, b)
#endif
#define _O(a,...)      printf(a,...)
#define _ERROR(a,...)  fprintf(stderr,a,...)

#define X86_NOP                         0x90

#define	DEFAULT_SUS_BUFFER_SIZE		128
#define	DEFAULT_ENABLE_LOGGING		0
#define DEFAULT_LOGFILE			"/tmp/impost.log"
#define DEFAULT_CONFIG_FILE		"~/.impostrc"
#define	DEFAULT_CAPTURE_DIRECTORY	"/tmp/impost-captures"
#define DEFAULT_SC_DEFINITIONS		"./impost.shellcodes"

#define	SERVER_CAPTURE			1
#define	SNIFFER_CAPTURE			2

struct config_options {
	char variable[128];
	int  value;
	char option[256];
};

struct shellcodes {
	char ascii_hex_pattern[255];
	char Description[255];
	int Defined;
};

#define	C_OPT_SUSPECT_BUFFER		0
#define	C_OPT_ENABLE_LOGGING		1
#define	C_OPT_LOGFILE			2
#define	C_OPT_OUR_BUFFER_SIZE		3
#define	C_OPT_CAPTURE_DIRECTORY		4
#define	C_OPT_SHELLCODE_DEFS		5

#define	F_OPEN_READONLY			"r"
#define F_OPEN_APPEND			"a+"

#define SHC_LINE_SIZE			256

/* server.c */
extern int Impost_Hexdump();
extern int Impost_Create_Server();
extern int Impost_Server_Loop();
extern int Impost_Accept_Connection();
extern int Impost_Serv_Read_Connection(int);
extern int Impost_Serv_Read(int, void *, int);
extern int Impost_Serv_Do_Capture(char *, int, int);
extern int Check_Flatpattern_NOPs(char *);
extern int Check_x86_NOPs(char *);
extern int Find_1byte_NOP_Start(char *, int);
extern int Detected_Buffer(char *, int, int, int, int, int);
extern unsigned long Find_Reversed_x86_Address(char *);
extern char *Impost_Get_TimeStamp();

/* conf.c */
extern int Load_Configuration(char *);

/* script.c */
extern int Perl_Load_Script(char *);
extern int Perl_Unload_Script();
extern int Perl_On_Server_Accept(char *, int);
extern int Perl_On_Server_Read(char *, int);

/* shcdefs.c */
extern char  SHC_Str2H(char *);
extern char *SHC_PutTogetherBuffer(char *);
extern int   SHC_Check_If_Known(char *);
extern int   SHC_Parse_Defs_File();
extern int   SHC_Has_X86_Opcode(char *);

/* base64.c */
extern char *Base64_Encode(const char *);
extern char *Base64_Decode(const char *);
extern int   Base64_Decode_byte(int);

/* log.c */
extern int write_log(const char *, ...);

/* main.c */
extern char *Main_Expand_path(char *);
extern int Main_Usage(char *);

#ifdef HAVE_LIBPCAP

/* packets.c */
extern int Decode_Packet();
extern int Impost_Sniff_Loop(int);
extern int Set_Datalink_Offset(pcap_t *);
extern int Find_Network_Device();

#endif

/* EOF */
