/*
 * Impost(er) by ziplock (http://ziplock.b4b0.net)
 * File: log.c (logging functions)
 *
 * Comments: sickbeatz@hotmail.com
 * IRC: #b4b0 on EFNet
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 */

#include "impost.h"

extern struct config_options config_opt[];
FILE *log_fd;

/*
** Write log entry
*/
int write_log(const char *format, ...)
{
    va_list args;
    char *log_entry;
    int fp = 0;

    log_entry = (char *) malloc(256);
    memset(log_entry, 0, 256);

    /* Setup the log entry buffer */
    va_start(args, format);
    while (format[fp])
    {
        if (format[fp] == '%')
        {
            fp++;
            switch (format[fp])
            {
                case 's':
                    sprintf(log_entry, "%s%s",log_entry,
                        va_arg(args, char *));
                    break;
                case 'd':
                    sprintf(log_entry,
                        "%s%d",
                        log_entry,va_arg(args, int));
                    break;
            }
        } else
            log_entry[strlen(log_entry)] = format[fp];
        fp++;
    }
    va_end(args);

    if ((log_fd = fopen(config_opt[2].option, "a+")) == NULL)
    {
        perror("fopen()");
        return -1;
    }

    fprintf(log_fd, "%s\n", log_entry);
    fclose(log_fd);

    if (log_entry != NULL)
	free(log_entry);

    log_entry = NULL;

    return 0;
}

/* EOF */

